public class ListaStati {
	
	public static void setSorting(Sorting aSorting) {
		sorting = aSorting;
	}
	
	public static Sorting getSorting() {
		return sorting;
	}
	
	public static void setView(AlgoritmiView aView) {
		view = aView;
	}
	
	public static AlgoritmiView getView() {
		return view;
	}
	
	public static void resetta() {
		statoAttuale = new Stato(); //(next e prec sono gia' a null e a me vanno bene cosi')
	}
	
	public static void fineStato() { //Scrive le informazioni nello stato attuale della lista e ne crea uno nuovo
		statoAttuale.leggiStato(sorting);
		Stato nuovoStato = new Stato();
		statoAttuale.setNext(nuovoStato);
		nuovoStato.setPrec(statoAttuale);
		statoAttuale = nuovoStato;
	}
	
	private static void mostraStato() { //Imposta il tutto secondo le informazioni dello stato attuale della lista
		statoAttuale.scriviStato(sorting);
		view.repaint();
	}
	
	public static int indietro() {
		if (statoAttuale.getPrec() != null) { //Se prima c'era uno stato, bon, senno' (non dovrebbe mai essere, perche' all'inizio non puo' essere in pausa e quindi consentire di premere step indietro!) ritorna fallimento
			statoAttuale = statoAttuale.getPrec();
			mostraStato();
			return 0;
		} else {
			return -1;
		}
	}
	
	public static int avanti() {
		if (statoAttuale.getNext() != null) {
			statoAttuale = statoAttuale.getNext();
			mostraStato();
			return 0;  //Ritorna successo: c'era uno stato da mostrare
		} else {
			return -1; //Ritorna fallimento: non c'era uno stato da mostrare: Se vuoi continuare, premi step!
		}
	}
	
	public static Stato getStato() { //La uso solo per vedere se e' null
		return statoAttuale;
	}
	
	private static Stato statoAttuale = null;
	private static Sorting sorting = null;
	private static AlgoritmiView view = null;
}