import java.util.Vector;

public class Stato {
	
	public Stato() {
		
	}
	
	public void leggiStato(Sorting sorting) {
		if (sorting == null) return;
		if (sorting.getVettore() != null) {
			this.vettore = new int[sorting.getVettore().length];
			for (int i=0;i<sorting.getVettore().length;i++) {
				this.vettore[i] = sorting.getVettore()[i];
			}	
		}
		if (sorting.getMessaggio() != null) 
			this.messaggio = new String(sorting.getMessaggio());
		this.primoEvidenziato = sorting.getPrimoEvidenziato();
		this.secondoEvidenziato = sorting.getSecondoEvidenziato();
		this.lineaEvidenziata = sorting.getLineaEvidenziata();
		this.nodoSegnato = Albero.getNodoEvidenziato();
	}
	
	public void scriviStato(Sorting sorting) {
		if (sorting == null) {
			return;
		}
		if (this.vettore != null) {
			for (int i=0;i<this.vettore.length;i++) {
				sorting.getVettore()[i] = this.vettore[i];
			}
		}
		if (this.messaggio != null) sorting.setMessaggio(new String(this.messaggio));
		sorting.setPrimoEvidenziato(this.primoEvidenziato);
		sorting.setSecondoEvidenziato(this.secondoEvidenziato);
		sorting.evidenziaLinea(this.lineaEvidenziata);
		Albero.evidenziaNodo(this.nodoSegnato);
	}
	
	public void setNext(Stato next) {
		this.next = next;
	}
	
	public Stato getNext() {
		return next;
	}
	
	public void setPrec(Stato prec) {
		this.prec = prec;
	}
	
	public Stato getPrec() {
		return prec;
	}
	
	Stato next = null;
	Stato prec = null;
	int[] vettore  = null;
	String messaggio = null;
	int primoEvidenziato = -1, secondoEvidenziato = -1;
	int lineaEvidenziata = 0;
	Nodo nodoSegnato = null;
}