import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Observer;
import java.util.Observable;

public class AlgoritmiView extends JComponent implements Observer {
	
	public AlgoritmiView(AlgoritmiAnimati theApp) {
		this.theApp = theApp;
	}
	
	public void repaint() { //Lo rifaccio per fare double-buffering... Ma non so quanto bene vada..
		Image image = this.createImage(this.getSize().width, this.getSize().height);
		Graphics g = image.getGraphics();
		g.setColor(this.getBackground());
		g.fillRect(0,0,this.getSize().width,this.getSize().height);
		g.setColor(this.getForeground());
		paint(g);
		this.getGraphics().drawImage(image,0,0,null);
	}
	
	public void update(Observable obs, Object o) {
		if (o != null) messaggio.scriviMessaggio((String)o);
		this.repaint();
	}
	
	public void paint(Graphics g1) {
		Graphics2D g = (Graphics2D)g1;
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g.setPaint(theApp.getColore());
		theApp.getModel().draw(g1);
	}
	
	
	public class AlgoritmiMessaggio extends JLabel {
		public AlgoritmiMessaggio(String testo) {
			super(testo);
			messaggio = this;
		}
		
		public void scriviMessaggio(String messaggio) {
			this.setText(messaggio);
		}
	}
	
	private AlgoritmiAnimati theApp = null;
	private AlgoritmiMessaggio messaggio = null;
}

